/*
AlgorithmConfig
	alpha
	ITE_MAX
	inputDims
	
AlgorithmState
	iteration
	current_example_index
	error_count
	W
	b

Dataset
	examples
	classes
	datasetConfig

DatasetConfig
	examples_per_class
	center_distance
	
UIConfig
	scene
	camera
	controls
	classOneColor
	classZeroColor
	unitLength
	planeSize	
	
AnimationState :: (initializing, checkStoppingConditions, comparingOutput, updatingWeights)	
	
initializeState(AlgorithmState)
initializeState(AlgorithmState, W, b)
createDataset(DatasetConfig)
createDataset(DatasetConfig, examples, classes)

iterationHasFinished(AlgorithmState, exampleCount)
algorithmHasFinished(AlgorithmState, AlgorithmConfig)
update(AlgorithmState, dataset, AlgorithmConfig)
isCurrentExampleCorrectlyClassified(AlgorithmState, dataset)
----------------------------------------
	
*/
//deprecated
function Perceptron () {		
	this.oneIteration = function(exampleSet, targets){		
		for (var e=0; e < exampleSet.length; e++){				
			var net = this.b;
			for (var i=0; i < this.inputDims; i++) 
				net += this.W[i] * exampleSet[e][i];
			var y = net > 0 ? 1 : 0;	
			if (y != targets[e]) {
				for (var i=0; i < this.inputDims; i++) 
					this.W[i] += this.alpha * (targets[e] - y) * exampleSet[e][i];
				this.b += this.alpha * (targets[e] - y);
			}	
		}					
	};
	this.outputForOneExample = function(example){
		var net = this.b;
		for (var i=0; i < this.inputDims; i++) 
			net += this.W[i] * example[i];
		return net > 0 ? 1 : 0;				
	};
	this.updateWithExample = function(example, output, target){
		if (output != target) {
			for (var i=0; i < this.inputDims; i++) 
				this.W[i] += this.alpha * (target - output) * example[i];
			this.b += this.alpha * (target - output);
		}	
	};
	this.apply = function (exampleSet) {
		var output = [];
		for (var e=0; e < exampleSet.length; e++) {
			var net = this.b;
			for (var i=0; i < this.inputDims; i++) 
				net += this.W[i] * exampleSet[e][i];
			var y = net >= 0 ? 1 : 0;			
			output.push(y);
		}
		return output;
	};	
}

//new implementation below

function update(algorithmState, dataset, algorithmConfig){
	var target = dataset.classes[algorithmState.current_example_index];
	var example = dataset.examples[algorithmState.current_example_index];
	var output = outputForOneExample(algorithmState, example);
	if (output != target) {
		for (var i=0; i < example.length; i++) 
			algorithmState.W[i] += algorithmConfig.alpha * (target - output) * example[i];
		algorithmState.b += algorithmConfig.alpha * (target - output);
		algorithmState.error_count++;
	}	
}

function outputForOneExample(algorithmState, example){
	var net = algorithmState.b;
	for (var i=0; i < example.length; i++) 
		net += algorithmState.W[i] * example[i];
	return net > 0 ? 1 : 0;				
}

function isCurrentExampleCorrectlyClassified(algorithmState, dataset){
	var target = dataset.classes[algorithmState.current_example_index];
	var example = dataset.examples[algorithmState.current_example_index];
	var output = outputForOneExample(algorithmState, example);
	return (output == target);
}

function iterationHasFinished(algorithmState, exampleCount){
	//return algorithmState.current_example_index == exampleCount - 1;
	return algorithmState.current_example_index == exampleCount;
}

function algorithmHasFinished(algorithmState, algorithmConfig){
	return (algorithmState.iteration == algorithmConfig.ITE_MAX) || (algorithmState.error_count == 0);
}

function beginIteration(algorithmState){
	algorithmState.current_example_index = 0;
	algorithmState.error_count=0;
	algorithmState.iteration++;
}

function nextExample(algorithmState, exampleCount){
	if (iterationHasFinished(algorithmState, exampleCount)) {
		beginIteration(algorithmState);				
	}	
	else	
		algorithmState.current_example_index++;
}





